import { world, BlockPermutation, ItemStack, GameMode } from "@minecraft/server";

/** @type {import("@minecraft/server").BlockCustomComponent} */
const pathVar = {
    onPlace({block}) {
        const rand = (Math.floor(Math.random() * 2));
        const permutation = BlockPermutation.resolve(block.typeId, {"gao:var": rand});
        block.setPermutation(permutation)
    }
}

world.beforeEvents.worldInitialize.subscribe(({ blockComponentRegistry }) => {
    blockComponentRegistry.registerCustomComponent(
        "gao:path_variation",
        pathVar
    );
});

const paths = [
    "gao:stone_path", "gao:brick_path",
    "gao:oak_plank_path", "gao:spruce_plank_path",
    "gao:birch_plank_path", "gao:jungle_plank_path",
    "gao:acacia_plank_path", "gao:dark_oak_plank_path",
    "gao:mangrove_plank_path", "gao:cherry_plank_path",
    "gao:pale_oak_plank_path", "gao:bamboo_plank_path",
    "gao:crimson_plank_path", "gao:warped_plank_path",
    "gao:bamboo_path", "gao:resin_brick_path",
    "gao:deepslate_path"
]

world.afterEvents.playerPlaceBlock.subscribe((event) => {
    const { player, block } = event;
    const blockId = block.typeId;
  
    if (!player?.isValid() || !block) return;
    if (paths.includes(blockId)) {
        const blockBelow = block.below();
        if (paths.includes(blockBelow?.typeId)) {
          block.setType("minecraft:air");
          if (player.getGameMode() === GameMode.survival) {
            const item = new ItemStack(blockId, 1);
            player.getComponent("minecraft:inventory")?.container?.addItem(item);
          }
        }
      }
  });